spritefade:    ;d0= input brightness 0->$FF
               ;if <0 then o , if >$FF then $FF
               bltzl d0,@make0
               move  d0,r0
@make0:        li    d1,$FF
               subu  d2,d1,d0  ;$FF-brightness
               bltzl d2,@makemax
               li    d0,$FF
@makemax:      lw    a0,RDPendaddy
               sll   d1,d0,24       ;R
               sll   d2,d0,16       ;G
               or    d1,d2
               sll   d3,d0,8        ;B
               or    d1,d3
               or    d1,d0          ;ALPHA
               li    d5,$FA000000
               sw    d5,0(a0)
               sw    d1,4(a0)
               addu  a0,8
               sw    a0,RDPendaddy
               jr ra
               nop
                        
setrendermode:   ;d0-> rendering mode 0=FILL, 1=1CYC , 2=2CYC
                 sll d0,3   ;8 byte offset
                 lw  a0,RDPendaddy
                 la  a1,@RENDERMODE
                 addu a1,d0
                 li   d7,$E7000000
                 sw   d7,0(a0)
                 sw   r0,4(a0)
                 lw   d1,0(a1)
                 sw   d1,8(a0)
                 lw   d2,4(a1)
                 sw   d2,12(a0)
                 addu a0,16
                 sw   a0,RDPendaddy
                 jr ra
                 nop

@RENDERMODE:

         DW $EFB92CBF ;0 ;FILL
         DW $0F0A4000    ;$0C182078 

         DW $EF990000 ;1
         DW $88000000

         DW $EF990000 ;2
         DW $88000000

         DW $EF990000 ;3
         DW $88000000

         DW $EF990000 ;4
         DW $88000000

         DW $EF990000 ;5
         DW $08026003

         DW $EF990000 ;6
         DW $08007003

         DW $EF990000 ;7
         DW $8000A000

         DW $EF990000 ;8
         DW $000B8000

         DW $EF990000 ;9
         DW $025B8000

         DW $EF990000 ;10  a
         DW $025B8000

         DW $EF990000 ;11  b
         DW $88050000

         DW $EF990000 ;12  c
         DW $8000A300

         DW $EF990000 ;13  d
         DW $88003010

         DW $EF990000 ;14  e
         DW $88060303

         DW $EF990000 ;15  f
         DW $88007003

         DW $EF990000 ;16  10
         DW $F800F000

         DW $EF990000 ;17  11
         DW $025B8000

         DW $EF990000 ;18  12
         DW $8000A300

         DW $EF990000 ;19  13
         DW $8000A300

         DW $EF990000 ;20  14
         DW $8000A300

         DW $EF990000 ;21  15
         DW $8001A320

         DW $EF990000 ;22  16
         DW $8000F000

         DW $EF990000 ;23  17
         DW $8000F003

         DW $EF990000 ;24  18
         DW $88049200

         DW $EF990000 ;25  19
         DW $F800F000

         DW $EF990000 ;26  1A
         DW $8000A300

         DW $EF990000 ;27  1B
         DW $F800E000

         DW $EF990000 ;28  1C
         DW $8000A300

         DW $EF990000 ;29  1D
         DW $88003230

         DW $EF990000 ;30  1E
         DW $F800E000

         DW $EF990000 ;31  1F
         DW $88060303

         DW $EF990000 ;32  20
         DW $88060303

         DW $EF990000 ;33  21
         DW $80003003

         DW $EF890000 ;34  22
         DW $80006003

         DW $EF890000 ;35  23
         DW $80076003

         DW $EF890000 ;36  24
         DW $88076003

         DW $EF990000 ;37  25    HJHJK
         DW $80007003

            DW $EF990000 ;38  26
            DW $81006003

         DW $EF890000 ;39  27
         DW $08057000

         DW $EF990000 ;40  28
         DW $08057003

         DW $EF990000 ;41  29
         DW $08057020

         DW $EF890000 ;42  2A
         DW $00000003

         DW $EF890000 ;43  2B
         DW $80076003            GOOD

         DW $EF890000 ;44  2C
         DW $80007000

         DW $EF890000 ;45  2D     ;BLUE
         DW $888B6004

         DW $EF890000 ;46  2E     ;BLUE
         DW $888B6003

         DW $EF890000 ;47  2F     ;BLUE
         DW $888B6003

         DW $EF990000 ;48  30
         DW $80227000

         DW $EF990000 ;49  31
         DW $80267000

         DW $EF890000 ;50  32     ;BLUE
         DW $888B6000


changeobjectcolor:    ;d0->color1  , d1= color2
                      ;a0 -> pointer to object
                 lw   d2,-9*4(a0)   ;number of faces
@next
                 addu a0,14*4    ;space betwwen each face 
                 sw   d0,-4(a0)
                 addu d2,-1
                 beqz d2,@exit
                 addu a0,14*4
                 sw   d1,-4(a0)
                 addu d2,-1
                 bnez d2,@next
                 nop
@exit            jr ra
                 nop

fillrect:       ;d0=x d1=y              copper effect!!
                ;d2=width d3=height
                ;d4 = color
                bltz d2,@exit
                nop
                bltz d3,@exit
                addu d8,d0,d2     ;x+height
                blez d8,@exit
                addu d7,d1,d3     ;y+width
                blez d7,@exit
                addu d8,d0,-320
                bgez d8,@exit     ;x>320?
                addu d7,d1,-240
                bgez d7,@exit     ;y>240
                nop


                lw    a0,RDPendaddy
                li    d8,$E7000000
                sw    d8,0(a0)
                sw    r0,4(a0)
                addu  a0,8
                li    d7,$F7000000   ;setfill color
                sw    d7,0(a0)
                sw    d4,4(a0)

                li    d7,$F6000000    ;fillrect
                addu  d5,d0,d2      ;x+width
                addu  d6,d5,-320
                bgtzl  d6,@make320
                li    d5,320
@make320        sll   d5,14    ;lrx<<14
                or    d7,d5

                addu  d6,d1,d3   ;y+height
                addu  d8,d6,-240
                bgtzl d8,@make240
                li    d6,240
@make240        sll   d6,2       ;lry<<2
                or    d7,d6
                sw    d7,8(a0)

                bltzl d0,@make0
                li    d0,0
@make0          bltzl d1,@make02
                li    d1,0
@make02

                sll   d0,14      ;x
                sll   d1,2       ;y
                or    d0,d1
                sw    d0,12(a0)
                addu  a0,16
                sw    a0,RDPendaddy
@exit           jr  ra
                nop

setscissor:    ; d0=topleft_x  d1=topleft_y
               ; d2=width      d3=height
               bltzl d0,@make0
               li    d0,0
@make0         bltzl d1,@make02
               li    d1,0
@make02        
               lw    a0,RDPendaddy
               li    d6,$E7000000
               sw    d6,0(a0)
               sw    r0,4(a0)
               addu  a0,8
               li    d7,$ED000000  ;setscissor
               sll   d6,d0,12+2    ;ulx
               or    d7,d6
               sll   d5,d1,2    ;uly
               or    d7,d5
               sw    d7,0(a0)    ;word1
               addu  d0,d2       ;lrx
               addu  d4,d0,-320
               bgtzl d4,@make320 ;?out of bounds
               li    d0,320
@make320       sll   d0,12+2
               addu  d1,d3       ;lry
               addu  d4,d1,-240
               bgtzl d4,@make240 ;?out of bounds
@make240       li    d1,240
               sll   d1,2
               or    d0,d1
               sw    d0,4(a0)
               addu  a0,8
               sw    a0,RDPendaddy
               jr ra
               nop

setblendcolor:     ;d0= color
               lw   a0,RDPendaddy
               li   d1,$E7000000
               sw   d1,0(a0)
               sw   ra,4(a0)
               li   d2,$F9000000
               sw   d2,8(a0)
               sw   d0,12(a0)
               addu a0,16
               sw   a0,RDPendaddy
               jr ra
               nop
