
dosprite:   module
               lw     a0,RDPendaddy
               lw     d0,width         ;width
               lw     d1,height        ;height
               lw     d2,xposition     ;x pos
               lw     d3,yposition     ;y pos
    ;check for out of bounds conditions
               lw     d4,xscale
               addu   d8,d0,d2      ;width+xpos
               addu   d8,d8,d4      ;xend+xscale
               blez   d8,nosprite  ;too far left
               li     d7,322
               subu   d7,d7,d2      ;max screen width-xposition
               blez   d7,nosprite  ;too far right
               lw     d5,yscale
               addu   d8,d1,d3      ;height+ypos
               addu   d8,d8,d5      ;yend+yscale
               blez   d8,nosprite  ;too far up
               li     d7,245
               subu   d8,d7,d3
               blez   d8,nosprite  ;too far down
       ;        lw     d7,xscale
       ;        lw     d8,yscale
               addu   d7,d4,d0   ;width+xscale
               blez   d7,nosprite
               addu   d8,d5,d1   ;height+yscale
               blez   d8,nosprite

               li     d7,245
               addu   d8,d1,d3     ;height+ypos
               subu   d7,d7,d8     ;max screen height-bottom of sprite
               bltzl   d7,@heightnotok
               addu   d1,d1,d7     ;height=height-difference
@heightnotok:
               lw     a6,spritepointer   ;point to graphics
               bgez   d3,@yposok
               negu   d7,d3        ;number of lines need to chop off

               sll    d8,d0,1      ;texel size
               multu  d8,d7
               mflo   d7
               addu   a6,a6,d7     ;move graphics pointer down
               addu   d1,d1,d3     ;make height shorter
               move   d3,r0        ;make ypos 0

@yposok
               move   a1,d0       ;save original width/height
               move   a2,d1    
;               addiu  d1,d1,1    ;height-1
               lw     d4,xscale
               lw     d5,yscale
nextsprite:
               li      d8,$FD100000 ;setTimg
               sw      d8,0(a0)
               sw      a6,4(a0)
                addiu   a0,a0,8
               li      d8,$F5100000  ;SetTile
               sw      d8,0(a0)
               li      d7,$00080200  ;0
               sw      d7,4(a0)
                addiu   a0,a0,8
               li      d8,$E6000000  ;RDPLoadSync
               sw      d8,0(a0)
               sw      r0,4(a0)
                addiu   a0,a0,8
               li      d8,$F3000000
               sw      d8,0(a0)

               li      d7,$007FF000 ;077ff
               srl     d6,d0,2     ;width/4
               beql    d6,r0,@make1
               li      d6,1
@make1:        addiu   d8,d6,2048-1
               divu    d8,d6
               mflo    d8
               or      d7,d7,d8
               sw      d7,4(a0)      ;LoadBlock
                addiu   a0,a0,8
               li      d8,$E7000000  ;RDPPipesync
               sw      d8,0(a0)
               sw      r0,4(a0)
                addiu   a0,a0,8
               li      d8,$F5100000
               srl     d7,d0,2         ;width/4
               sll     d7,d7,9         ;<<9
               or      d8,d8,d7
               sw      d8,0(a0)
               li      d7,$00080200  ;$0000000E
               sw      d7,4(a0)        ;SetTile
                addiu   a0,a0,8
               li      d8,$F2000000
               sw      d8,0(a0)
               addiu   d7,d0,-1        ;(width-1)*4
               sll     d7,d7,2
               or      d6,r0,d7
               sll     d7,d7,12
               or      d6,d6,d7
               sw      d6,4(a0)
                addiu   a0,a0,8
               li      d8,$E4000000    ;TextREct
               addu    d7,d0,d2        ;xpos+width
               addu    d7,d7,d4        ;xend+xscale
               li      d6,322
               subu    d6,d6,d7        ;324-xend
               bltzl   d6,@no_adjustwidth
               li      d7,322
@no_adjustwidth:

               andi    d7,d7,$3FF      ;weed out shit

               sll     d7,d7,14        ;xend
               or      d8,d8,d7
               li      d6,4095/2
               divu    d6,d0
               mflo    d6              ;4095/2/width
               subu    d7,d6,d1        ;lines avail-height
               li      d11,1      ;signal finish!!
               bgezl   d7,lastsprite
               addu    d6,r0,d1        ;draw only height lines left

               negu    d1,d7      ;lines left move to height
               li      d11,0       ;signal to do more

lastsprite:
               multu   d0,d6      ;width*lines to draw
               mflo    d7
               sll     d7,d7,1    ;*2
               addu    a6,a6,d7   ;increment Timg pointer
               addu    d6,d6,d3   ;lines to draw+ypos
             addu    d6,d6,d5   ;yend+yscale
               li    d9,245
               subu  d9,d9,d6    ;245-yend
               bgez  d9,@yend_ok
               nop
               li    d11,1   ;finished
               li    d6,245
@yend_ok
               addu    d7,r0,d6      ;store next ypos in d7 for later
               sll     d6,d6,2    ;yend
               andi    d6,d6,$FFF ;weed out shit
               or      d8,d8,d6
               sw      d8,0(a0)
               sll     d6,d3,2    ;ypos<<2
               andi    d6,d6,$FFF ;weed out shit

               bltzl    d2,@xposfix
               move     d8,r0
               move     d8,d2
@xposfix
               andi    d8,d8,$3FF ;weed out shit
               sll     d8,d8,14   ;xstart
               or      d8,d8,d6
               sw      d8,4(a0)
               addu    d3,r0,d7   ;next ypos in current sprite
          ;  addu    d3,d3,d5   ;next ypos+yscale

               bgezl   d2,@no_xposfix
               move    d6,r0
               subu    d6,r0,d2
               sll     d6,d6,(16+5)  ;image shift
@no_xposfix
               sw      d6,8(a0)

               addu    d8,d4,a1   ;ourxscale+originalwidth
               sll     d8,d8,16
               divu    d8,a1      ;xscale<<16 / width
               mflo    d8
               nop
               lw      d7,spritescalefactor  ;$03AE0000
               divu    d7,d8      ;$04000000/ above#
               mflo    d9
               addu    d8,d5,a2   ;ouryscale+originalheight
               sll     d8,d8,16
               divu    d8,a2      ;yscale<<16 / height
               mflo    d8
               nop
               nop
               divu    d7,d8      ;$04000000/ above#
               mflo    d7
;               andi    d9,d9,-2
;               andi    d7,d7,$FFFEFFFF     
               sll     d9,d9,16
               or      d9,d9,d7   ;xscale|yscale

               sw      d9,12(a0)
               li      d7,$E7000000
               sw      d7,16(a0)
               sw      r0,20(a0)
                addiu   a0,a0,24

               beqz    d11,nextsprite
               nop
               sw      a0,RDPendaddy
nosprite:
               jr ra
               nop

sprite_end:    lw      a0,RDPendaddy
               li      d9,8  ;8 words
               la      a1,pipesync
@copy          lw      d0,0(a1)
               addiu   a1,a1,4
               sw      d0,0(a0)
               addiu   d9,d9,-1
               bnez    d9,@copy
               addiu   a0,a0,4

               addiu   a0,a0,(8)*4
               sw      a0,RDPendaddy
               jr   ra
               nop
          modend

pipesync:       dw $E7000000
                dw $00000000

setcombine:     dw $FC300000
                dw $00000300

setothermode: ; dw $EF900CC1
              ; dw $881A2078 
     dw $EF990000
     dw $88000000
setblendcolor:
     dw $f9000000
     dw $00001000

spritepointer: dw 0
xposition: dw xpos
yposition: dw ypos
xscale: DW 0
yscale: DW 0
width: DW width1
height:  DW height1
spritescalefactor:  DW $04000400 ;$03AE0000
