vballs:
vballangles: DW 0,0,$46  
vballcount: dw 12
vballgraphics: dw green32
vballsize: dw 32
vballxcenter: DW 160
vballycenter: DW 120
vballzoom:   DW 0 ;275   
vballcoordinates: dw pointer


vscale: dw $F0
vscale2: dw $15E
vballcheckdata: dw $80680000

drawvballs:      ;a0=object
            la   a1,vballs
            addu a0,-3*4
            li   d1,9   ;10 number to move
@copy       lw   d0,0(a0)
            addu a0,4
            sw   d0,0(a1)
            addu d1,-1
            bnez d1,@copy
            addu a1,4

            move a4,a0
;            sw      a0,0(a1)  ;coordinates
            la      a3,Vballangles
;            lw      a4,vballcoordinates
            lw      a5,vballcheckdata
            lw      a9,vballcount ;number of vballs
            la      a0,sinuslist
            addiu   a1,a0,254    ;cos
@plotloop:
            lh  d0,0(a4)     ;coords
            lh  d1,2(a4)
            lh  d2,4(a4)
            lw  d3,0(a3)     ;angles
            lw  d4,4(a3)
            lw  d5,8(a3)
      sll  d3,d3,1   ;rotate 3 points with 3 angles
      sll  d4,d4,1   ;d0-d2  points (x,y,z)
      sll  d5,d5,1   ;d3-d5  angles (dx,dy,dz)
      addu a2,a0,d3  ;a0,a1  pointers to sin cos table
      lh   d6,0(a2)   ;sin(+x)
      mult d2,d6
      mflo d9         ;z*sin(+x)
      addu a2,a1,d3
      lh   d7,0(a2)   ;cos(+x)
      mult d1,d7
      mflo d10        ;y*cos(+x)
      subu d9,d10,d9  ;y*cos(+x)-z*sin(+x)
      sll  d9,d9,2
      sra  d9,d9,16   ;Y1 * 4 /65536
      mult d1,d6
      mflo d6         ;y*sin(+x)
      nop
      nop
      mult d2,d7
      mflo d7         ;z*cos(+x)
      addu d3,d7,d6   ;z*cos(+x)+ysin(+x)
      sll  d3,d3,2    
      sra  d3,d3,16   ;Z1 * 4/65536
      addu a2,a0,d4
      lh   d6,0(a2)   ;sin(+y)
      mult d3,d6
      mflo d8         ;Z1*sin(+y)
      addu a2,a1,d4
      lh   d7,0(a2)   ;cos(+y)
      mult d0,d7
      mflo d10        ;x*cos(+y)
      subu d4,d10,d8  ;x*cos(+y)-z*sin(+y)
      sll  d4,d4,2
      sra  d4,d4,16   ;X2 *4/65536
      mult d0,d6
      mflo d6         ;z*sin(+y)
      nop
      nop
      mult d3,d7
      mflo d7         ;Z1*cos(+y)
      addu d2,d7,d6   ;x*sin(+y) + Z1*cos(+y)
      sll  d2,d2,2
      sra  d2,d2,16   ;final z coordinate
      addu a2,a0,d5
      lh   d6,0(a2)   ;sin(+z)
      mult d6,d9
      mflo d10        ;Y1 * sin(+z)
      addu a2,a1,d5
      lh   d7,0(a2)   ;cos(+z)
      mult d7,d4
      mflo d11        ;X2 * cos(+z)
      subu d0,d11,d10 ;X2*cos(+z)-Y1*sin(+z)
      sll  d0,d0,2
      sra  d0,d0,16   ;final X coordinate
      mult d4,d6
      mflo d6         ;X2*sin(+z)
      nop
      nop
      mult d9,d7
      mflo d7         ;Y1*cos(+z)
      addu d1,d6,d7   ;X2*sin(+z)+Y1*cos(+z)
      sll  d1,d1,2
      sra  d1,d1,16   ;final y coordinate

      addiu a4,a4,6     ;increment coord  pointer

      addu  d2,256
      beqzl d2,@make1
      li    d2,1
@make1
      lw    d3,vballzoom
      mult  d3,d0     ;x*zoom
      mflo  d0
      nop
      nop
      div   d0,d2     ;/z
      mflo  d0        ;projected x
      nop
      nop
      mult  d3,d1     ;y*zoom
      mflo  d1
      nop
      nop
      div   d1,d2     ;/z
      mflo  d1        ;projected y
      lw    d3,vballxcenter
      addu  d0,d3
      lw    d4,vballycenter
      addu  d1,d4

      sh    d0,0(a5)
      sh    d1,2(a5)
      sh    d2,4(a5)
      addu  a5,6

@skip:
      addiu a9,a9,-1
      bgtz  a9,@plotloop
      nop

           lw    a0,vballcheckdata
           addiu a0,a0,4     ;get to z value
           lw    d0,vballcount  ;maxrow
           srl   d1,d0,1     ;maxrow/2 d1=offset
@topdo:    subu  d2,d0,d1    ;maxrow-offset d2=limit
@doloop:   li    d3,-1       ;d3=switch  = false(0) or neg
           li    d4,0        ;d4=row
@FOR:
           li    d9,6     ;get to z offset
           multu d9,d4
           mflo  d9
           addu  a9,a0,d9
           lh    d5,0(a9)    ;get z1
           li    d9,6
           multu d9,d1
           mflo  d9
           addu  a10,a9,d9   
           lh    d6,0(a10)    ;get z2   (a10 pointer)
           subu  d7,d5,d6
           bgez  d7,@itsbigger
           nop

           lh    a1,-4(a9)
           lh    a2,-2(a9)
 ;          lh    xx,0(a9) d5
           lh    a3,-4(a10)
           lh    a4,-2(a10)
 ;          lh    xx,0(a10) d6

           sh    a1,-4(a10)
           sh    a2,-2(a10)      ;swap data!!!!!
           sh    d5,0(a10)

           sh    a3,-4(a9)
           sh    a4,-2(a9)       ;swap data!!!!
           sh    d6,0(a9)


            move  d3,d4        ;switch=row
@itsbigger: subu  d9,d2,d4     ;limit-row
            bgtz  d9,@FOR      ;skip if limit reached
            addiu d4,d4,1      ;row = row+1
           subu  d2,d3,d1     ;Limit=switch-offset
           bgez  d3,@doloop
           nop
           srl   d1,d1,1
           bgtz  d1,@topdo
           nop

      lw   a0,vballcheckdata
      lw   d9,vballcount
      lw   d2,vballsize
      lw   a1,vballgraphics
      sw   a1,spritepointer
      sw   d2,width
      sw   d2,height
@nextvball
      lw   d4,vscale  ;255   
      lw   d5,vscale2
      lw   d6,vballzoom
      lh   d2,4(a0)
      multu d4,d6     ;vscale*zoom
      mflo  d4
      addu  d2,-256
      nop
      multu d2,d5     ;z*vscale2
      mflo  d5
      subu  d4,d5

      sw    d4,xscale
      sw    d4,yscale
      lh    d0,0(a0)
      lh    d1,2(a0)
      sw    d0,xposition
      sw    d1,yposition
      sw    ra,0(a8)
      sw    a0,-4(a8)
      sw    d9,-8(a8)
      jal   dosprite
      nop
      lw    ra,0(a8)
      lw    a0,-4(a8)
      lw    d9,-8(a8)
      addu  a0,6   ;next coord
      addu  d9,-1
      bnez  d9,@nextvball
      nop
      jr ra
      nop


green32:
 incbin d:\gfx\anim\balls\greenAA.raw
redwhite:
 incbin d:\gfx\anim\redw32.aa
blue16:
 incbin d:\gfx\anim\blue16.aa
  cnop 0,4
          
         dw 0,0,0      ;adds
         DW 0,0,$46    ;angles
pointer:  dw 12      ; count: 
 dw green32 ;vballgraphics:
 dw 32      ;vballsize:
 DW 160     ;vballxcenter:
 DW 120     ;vballycenter:
 DW 0       ;vballzoom: 
 
 include d:\pom99\objects\pointer.asm
 cnop 0,4

    dw 1,2,2
    dw 0,0,0
ball1:  dw 7
  dw redwhite
  dw 32
  dw 160
  dw 120
  dw 0
  

   DH $0010, $0010, $0000, $FFF3, $0010, $0000, $0010, $FFEC, $0000
   DH $0010, $0034, $0000, $002D, $0010, $0000, $0010, $0010, $FFE0
   DH $0010, $0010, $0020

  cnop 0,4

  dw 0,3,1
  dw 0,0,0
symbol:
  dw  17
  dw redwhite
  dw 32
  dw 160
  dw 120
  dw 0
   DH $0010, $0010, $0000, $FFF4, $0010, $0000, $FFD8, $0010, $0000
   DH $FFC4, $FFF8, $0000, $FFC5, $0029, $0000, $002C, $0010, $0000
   DH $0048, $0010, $0000, $005A, $FFF6, $0000, $005A, $002A, $0000
   DH $0010, $0032, $0000, $0010, $0054, $0000, $FFFD, $006D, $0000
   DH $0025, $006B, $0000, $0010, $FFEE, $0000, $0010, $FFCC, $0000
   DH $FFFE, $FFB2, $0000, $0021, $FFB1, $0000
  cnop 0,4

  dw 1,3,1
  dw 0,0,0
wave:
  dw  36
  dw blue16
  dw 16
  dw 140
  dw 120
  dw 0
  DH $FFD5, $FFCE, $0000, $FFE6, $FFCE, $0000, $FFF7, $FFCE, $0000
  DH $0008, $FFCE, $0000, $0019, $FFCE, $0000, $002A, $FFCE, $0000
  DH $FFD5, $FFE2, $0000, $FFE6, $FFE2, $0000, $FFF7, $FFE2, $0000
  DH $0008, $FFE2, $0000, $0019, $FFE2, $0000, $002A, $FFE2, $0000
  DH $FFD5, $FFF6, $0000, $FFE6, $FFF6, $0000, $FFF7, $FFF6, $0000
  DH $0008, $FFF6, $0000, $0019, $FFF6, $0000, $002A, $FFF6, $0000
  DH $FFD5, $000A, $0000, $FFE6, $000A, $0000, $FFF7, $000A, $0000
  DH $0008, $000A, $0000, $0019, $000A, $0000, $002A, $000A, $0000
  DH $FFD5, $001E, $0000, $FFE6, $001E, $0000, $FFF7, $001E, $0000
  DH $0008, $001E, $0000, $0019, $001E, $0000, $002A, $001E, $0000
  DH $FFD5, $0032, $0000, $FFE6, $0032, $0000, $FFF7, $0032, $0000
  DH $0008, $0032, $0000, $0019, $0032, $0000, $002A, $0032, $0000
  cnop 0,4
              


  dw 2,1,3
  dw 0,0,0
random:
  dw  30
  dw blue16
  dw 16
  dw 140
  dw 120
  dw 0
 DH $FFAE, $0007, $0000, $FFC6, $0000, $0000, $FFC0, $0028, $0000
 DH $0004, $0046, $0000, $FFD8, $0064, $0000, $0032, $0028, $0000
 DH $FFF4, $0020, $0000, $FFF8, $007A, $0000, $004C, $FFBC, $0000
 DH $FFD8, $0034, $0000, $000E, $FF80, $0000, $FFBA, $FFBC, $0000
 DH $0028, $FFC2, $0000, $FFC8, $FFE0, $0000, $FFCC, $FF90, $0000
 DH $003E, $006C, $0000, $FFF2, $FF90, $0000, $FFBA, $006C, $0000
 DH $0046, $FF82, $0000, $0004, $FFA0, $0000, $0008, $FFE6, $0000
 DH $0034, $FFE6, $0000, $FFF2, $005E, $0000, $FFE2, $FFC8, $0000
 DH $001E, $0042, $0000, $FFE8, $0038, $0000, $FFEE, $FFDE, $0000
 DH $0012, $001A, $0000, $FFF0, $FFFC, $0000, $001E, $FFFC, $0000
  cnop 0,4
  dw 1,0,3
  dw 0,0,0
tube:
  dw  9*9
  dw redwhite
  dw 32
  dw 140
  dw 120
  dw 0

 DH $003B, $FFF7, $FF80, $0025, $FFDE, $FF80, $0007, $FFDA, $FF80
 DH $FFEF, $FFEF, $FF80, $FFE5, $0010, $FF80, $FFF2, $0031, $FF80
 DH $000F, $0041, $FF80, $002C, $0037, $FF80, $003E, $001A, $FF80

 DH $003B, $FFF7, $FFA0, $0025, $FFDE, $FFA0, $0007, $FFDA, $FFA0
 DH $FFEF, $FFEF, $FFA0, $FFE5, $0010, $FFA0, $FFF2, $0031, $FFA0
 DH $000F, $0041, $FFA0, $002C, $0037, $FFA0, $003E, $001A, $FFA0

 DH $003B, $FFF7, $FFC0, $0025, $FFDE, $FFC0, $0007, $FFDA, $FFC0
 DH $FFEF, $FFEF, $FFC0, $FFE5, $0010, $FFC0, $FFF2, $0031, $FFC0
 DH $000F, $0041, $FFC0, $002C, $0037, $FFC0, $003E, $001A, $FFC0

 DH $003B, $FFF7, $FFE0, $0025, $FFDE, $FFE0, $0007, $FFDA, $FFE0
 DH $FFEF, $FFEF, $FFE0, $FFE5, $0010, $FFE0, $FFF2, $0031, $FFE0
 DH $000F, $0041, $FFE0, $002C, $0037, $FFE0, $003E, $001A, $FFE0

 DH $003B, $FFF7, $0000, $0025, $FFDE, $0000, $0007, $FFDA, $0000
 DH $FFEF, $FFEF, $0000, $FFE5, $0010, $0000, $FFF2, $0031, $0000
 DH $000F, $0041, $0000, $002C, $0037, $0000, $003E, $001A, $0000

 DH $003B, $FFF7, $0020, $0025, $FFDE, $0020, $0007, $FFDA, $0020
 DH $FFEF, $FFEF, $0020, $FFE5, $0010, $0020, $FFF2, $0031, $0020
 DH $000F, $0041, $0020, $002C, $0037, $0020, $003E, $001A, $0020

 DH $003B, $FFF7, $0040, $0025, $FFDE, $0040, $0007, $FFDA, $0040
 DH $FFEF, $FFEF, $0040, $FFE5, $0010, $0040, $FFF2, $0031, $0040
 DH $000F, $0041, $0040, $002C, $0037, $0040, $003E, $001A, $0040

 DH $003B, $FFF7, $0060, $0025, $FFDE, $0060, $0007, $FFDA, $0060
 DH $FFEF, $FFEF, $0060, $FFE5, $0010, $0060, $FFF2, $0031, $0060
 DH $000F, $0041, $0060, $002C, $0037, $0060, $003E, $001A, $0060

 DH $003B, $FFF7, $0080, $0025, $FFDE, $0080, $0007, $FFDA, $0080
 DH $FFEF, $FFEF, $0080, $FFE5, $0010, $0080, $FFF2, $0031, $0080
 DH $000F, $0041, $0080, $002C, $0037, $0080, $003E, $001A, $0080

 cnop 0,4
buckswap
  dw buck2

  dw 0,1,0
  dw 0,0,0

buck:
  dw  1
  dw buck1
  dw 40
  dw 140
  dw 120
  dw 0

   dh  -90,0,0 

  cnop 0,8
buck1:
 incbin d:\gfx\anim\buck\buck1a.raw
buck2:
 incbin d:\gfx\anim\buck\buck2a.raw
  cnop 0,4

