;copperefects
ANTBARS = 10
COPBARS:
;      R    G    B  A
;    1234512345123450
 DH %0000000000000100 ;1      TOP PORTION
 DH %0000000000000110 ;2
 DH %0000000000001000 ;3
 DH %0000000000001100 ;4
 DH %0000000000010100 ;5
 DH %0000000000011010 ;6
 DH %0000000000101000 ;7
 DH %0000000000101100 ;8
 DH %0000000000110000 ;9
 DH %0000000000110100 ;10
 DH %0000000000111000 ;11
 DH %0000000000111110 ;12
;    1234512345123450
 DH %1111100000000000 ;1     BOTTOM PORTION
 DH %1110000000000000 ;2
 DH %1101000000000000 ;3
 DH %1100000000000000 ;4
 DH %1011000000000000 ;5
 DH %1010000000000000 ;6
 DH %0110100000000000 ;7
 DH %0101000000000000 ;8
 DH %0110000000000000 ;9
 DH %0100000000000000 ;10
 DH %0011000000000000 ;11
 DH %0010000000000000 ;12
 cnop 0,4

coppersin: dw 0
coppersinspeed: dw 9
coppercenter: dw 400
strangebars:
            sw  ra,0(a8)

            lw  d5,coppersin
            li  d9,antbars  ;number of bars

coploop2
            la    a0,sinuslist
            andi  d5,$1ff
            sll   d6,d5,1
            addu  a0,d6
            lh    d6,0(a0)  ;sinus value
            li    d8,100
            multu d8,d6    ;-50..50
            mflo  d8
            sra   d8,14
            lw    d1,coppercenter
            addu  d1,d8,d1      ;70..170  ypos

            li  d8,24       ;number of lines
            la  a1,copbars
copper:
            lhu d4,0(a1)
            addu a1,2
            sll d7,d4,16
            or  d4,d7

            li   d0,0      ;x
            li   d2,320    ;width
            li   d3,0      ;height
            sw   d0,-4(a8)
            sw   d1,-8(a8)
            sw   d2,-12(a8)
            sw   d3,-16(a8)
            sw   d8,-20(a8)   ;bar height counter
            sw   d9,-24(a8)   ;bar total counter
            sw   d5,-28(a8)   ;sinus counter
            sw   a1,-32(a8)   ;color pointer
            jal  fillrect
            nop
            lw   d0,-4(a8)
            lw   d1,-8(a8)
            lw   d2,-12(a8)
            lw   d3,-16(a8)
            lw   d8,-20(a8)   ;bar height counter
            lw   d9,-24(a8)   ;bar total counter
            lw   d5,-28(a8)   ;sinus counter
            lw   a1,-32(a8)   ;color pointer
            addu d1,1   ;next y
            addu d8,-1
            bnez d8,copper
            nop
            lw   d7,coppersinspeed
            addu d5,d7
            addu d9,-1
            bnez d9,coploop2
            nop
            lw   d5,coppersin
            addu d5,3
            andi d5,$1ff
            sw   d5,coppersin

            lw  ra,0(a8)
            jr ra
            nop

topbar dw -1
bottombar dw 240+1
copbarpos: dw 0
purple = $31573157
WHITE  = $9EF79EF7
copper2:
            lw d7,copbarpos
            lw d1,topbar
            li d6,2
            addu d1,d7      ;topbar+whatever
;            addu d1,-20
            li   d4,WHITE
            li   d3,0      ;height


@nextbar
            li   d0,0      ;xpos
            li   d2,320    ;width
            sw   d6,-8(a8)
            sw   d1,-4(a8)
            sw   ra,0(a8)
            jal  fillrect
            nop
            lw   d6,-8(a8)
            lw   d1,-4(a8)
            lw   ra,0(a8)

            addu d1,-80
            li   d3,80-1
            li   d4,purple
            addu d6,-1
            bnez d6,@nextbar
            nop

            lw   d7,copbarpos
            lw   d1,bottombar
            subu d1,d7        ;y-coppos

            li   d6,2
            li   d4,WHITE
            li   d3,0      ;height


@nextbar2
            li   d0,0      ;xpos
            li   d2,320    ;width
            sw   d6,-8(a8)
            sw   d1,-4(a8)
            sw   ra,0(a8)
            jal  fillrect
            nop
            lw   d6,-8(a8)
            lw   d1,-4(a8)
            lw   ra,0(a8)

            addu d1,1
            li   d3,80
            li   d4,purple
            addu d6,-1
            bnez d6,@nextbar2
            nop
            jr ra
            nop
