            ;*****MAIN LOOP******

part1:

      jal Readcontroller1
      nop

SKIP:       jal     WTOF     ;wait TOF loop at Beginning
            nop

            jal swapframebuffers
            nop

            jal updatemod
            nop
            jal swapDLlists
            nop
; if (1=0)
            jal cursor2
            nop
            jal cursor
            nop
            jal showmem
            nop

            jal peekmem
            nop

            jal showloc
            nop
            jal showposit
            nop
            jal tellstatus
            nop
; endif







            lw   d1,logoypos
            bne  d1,81,nobars
            nop

            li   d0,0     ;fill mode
            jal  setrendermode
            nop
            jal  strangebars
            nop
            lw   d0,coppercenter
            addu d0,-1
            li   d1,0
            beql d0,119,nobarmove
            li   d1,1
            sw   d0,coppercenter
nobarmove   sb   d1,startcubes
nobars



            jal sprite_init
            nop
;*************claculate fade in for logo*********
            lw   d0,logoypos   ;logodrop in fade
            addu d0,200        
            li   d1,$FdFd
            multu d0,d1
            mflo  d0
            sra   d0,16
            li    d1,$FF
            subu  d0,d1,d0
            jal  spritefade
            nop
;*********end claculate fade in for logo*********

;********make logo shrink*************
           lw   d0,logoypos
           addu d0,1
           li  d1,82
           beq d1,d0,@skiplogo
           sw  d0,logoypos
;****end make logo shrink*************

             jal dologo
             nop
@skiplogo


;*********do objects when pointer finished*******
           lbu  d3,objecttoggle

           la   a0,buck
           lbu  d0,buckdelay
           addu d0,1
           li   d2,15
           sb   d0,buckdelay
           bne  d0,d2,@thisobject
           li   d2,0
           sb   d2,buckdelay
           lw   a1,buckswap    ;make buck walk
           lw   a2,buck+4
           sync
           sw   a1,buck+4
           sw   a2,buckswap

           
@thisobject
           lh    d2,objectdelay
           addu  d2,-1
           lbu   d1,scaletoggle2
           bgtzl d2,@dontzoom
           or    d1,1

           lw    d0,5*4(a0)   ;objects zoom factor
           beqzl d1,@addtozoom
           addu  d0,1
           addu  d0,-1
@addtozoom
           li    d2,0
           bgez  d0,@sameobject
           lb    d3,objecttoggle
           addu  d3,1
           andi  d3,3                ;next object!!
           sb    d3,objecttoggle

@sameobject

           bltzl d0,@dontzoom
           li    d1,0         ;start zoom out again

           beql d0,$100,@dontzoom    ;put delay when zoomed all the way out
           li   d2,400      ;how long to hold it
           sw   d0,5*4(a0)
@dontzoom  sh   d2,objectdelay
           sb   d1,scaletoggle2

           lw   d0,5*4(a0)
           sw   a0,-4(a8)
           jal  spritefade
           nop
           lw   a0,-4(a8)
           jal  addangles
           nop
           lw   a0,-4(a8)

           jal  drawvballs
           nop

           b    noobjectshow
           nop

changetube: 

           la    a0,tube+(6*4)+4   ;z-coordinates
           lh    d0,tubesin  
           la    a2,sinuslist
           li    d1,9
           li    d6,-128
@tubeloop2
           move  d3,d0
           li    d2,9
@tubeloop1
           andi  d3,$1ff
           sll   d4,d3,1
           addu  a1,a2,d4
           lh    d4,0(a1)
           li    d5,90
           multu d5,d4
           mflo  d4
           sra   d4,14
           addu  d4,d6
           sh    d4,0(a0)
           addu  a0,6
           addu  d2,-1
           bnez  d2,@tubeloop1
           addu  d3,22    ;sin freq
           addu  d1,-1
           bnez  d1,@tubeloop2
           addu  d6,32
           addu  d0,10    ;sin freq
           sh    d0,tubesin
           


noobjectshow
;***********end object show*****


          jal sprite_end
          nop
;************end of sprites*****************





            jal  End_displaylist
            nop
;******END OF RDP LIST************e

;****add angles for all objects*******


;****calculate scale for logo************
            lw  d0,logoypos
            sw  d0,logoy
            li  d4,$26666
            multu d0,d4
            mflo  d5
            move  d1,d5
            sra d1,16
            sw  d1,logox
            li  d2,$199
            negu d1
            multu d1,d2
            mflo  d1
            addu  d1,$10000
            sw    d1,logoxscale
            sw    d1,logoyscale
;****end calculate scale for logo************

;********ship joy move***********
            la   a1,pif2
            lh   d0,6(a1)
            move d1,d0
            sra  d0,8+2     ;l/r
            la   a0,Vinklar
            lw   d2,4(a0)   ;yaxis
            addu d2,d0
            andi d2,511
            sw   d2,4(a0)   ;yaxis
            lw   d3,0(a0)   ;xaxis
            sll  d1,24
            sra  d1,24+2    ;u/d
            addu d3,d1
            andi d3,511
            sw   d3,0(a0)   ;xaxis
;********end ship joy move***********


            jal  controller    ;read joy for debugging
            nop
            j part1
            nop

;*****logosway********************

            lw   d0,logosway_X
            la   a0,sinuslist
            sll  d1,d0,1 ;hword offset
            addu a1,a0,d1
            addu d0,d0,3
            andi d0,$1FF
            sw   d0,logosway_X
            lh   d2,0(a1)
            li   d3,198
            multu d3,d2
            mflo  d3
            sra   d3,14
;            sw    d3,logox

            lw   d0,logosway_Y   
            sll  d2,d0,1
            addu a1,a0,d2
            addu d0,d0,4
            andi d0,$1ff
            sw   d0,logosway_Y
            lh   d2,0(a1)
            li   d3,40
            multu  d3,d2
            mflo   d3
            sra    d3,14
            addu   d3,40
;            sw     d3,logoy

;*****end_logosway********************

logosway_X: dw 0
logosway_Y: dw 0
logoypos: dw -200
logolimit: dw 10

cube1blend: dh 0
blendtoggle: db 0
objectdelay: dh 0
waveballsin: dh 0
randomsin: dh 0
tubesin:  dh 0

buckdelay: db 0
colordelay: db 0
docube: db 0
scaletoggle: db 0
startcubes: db 0
objecttoggle db 0
scaletoggle2: db 0
  cnop 0,4
