                   ;d0=x pos
                   ;d1=y
                   ;d2=chars/line
                   ;d3=# of lines
                   ;a0=text pointer

varioustext:
bucktext
  db 'BUCKTOOTH BOB!'
USERTEXT
  db 'USER MODE'
CREDITS:
  DB '                                     ' ;-1
  DB 'CODE: DESTOP                         ' ;0 37
  DB 'MOD PLAYER: TITANIK                  ' ;1
  DB 'GREETS GO OUT TO:                    ' ;2
  DB 'TITANIK..WILDFIRE..LOOM..SISPEO      ' ;3
  DB 'NAGRA..LAC..JOVIS..ACTRAISER..HARTEC ' ;4
  DB 'OSI-C1P..TWINSEN..BRETT..STEVE       ' ;5
  DB 'ANGELO..WT-RIKER..LOCKE..ZILMAR      ' ;6
  DB 'M0TION..SOS..-DX-..PUREEVIL..ACEY    ' ;7
  DB 'JEB..DEMO..SNAKE..MCBAIN..CYRYX..NIL ' ;8
  DB ' -ACID- ..KIDSTARDUST..STE..LONGSHOT ' ;9
  DB 'POYZ..STUMBLE..YOGI..PAN..ULTRA      ' ;10
  DB 'COOLHAND..ERIC..NETFUCKER..ENNAY..NEP' ;11
  DB 'LOADED..-RIP-..ICARUS..JL-PICARD     ' ;12
  DB 'PSYCOSYS..BEEJ..ROB..BPOINT..FRAC    ' ;13
  DB 'DUDDIE..ENDO..TS-GARP..DATAWIZ       ' ;14
  DB 'HECTIC..REDBOX..ANARKO!              ' ;15
  DB 'AND ALL OTHERS IN N64 SCENE!!        ' ;16
  DB 'POWAH ASM!! :)                       ' ;17
  DB 'IS THERE MORE TO THIS DEMO?          ' ;18+1
  
  cnop 0,4
                        ;d0,d1=x,y
                        ;d2,d3=chars/line, # of lines
                        ;a0=text
placetext:
              move  d4,d2  ;save chars per line for later
              move  d5,d0  ;save xpos
              LI    d7,$10000/2
              sw    d7,xscale
              sw    d7,yscale
              LI    D6,16
              SW    D6,width
              sw    d6,height

@nextletter
              lbu   d8,0(a0)
              addu  a0,1
              addu  d8,-32
              BEQZ  D8,@SKIPSPACE
              sll   d8,9
              la    a1,placegraphics
              addu  a1,d8
              sw    a1,spritepointer
              sw    d0,xposition
              sw    d1,yposition
              sw    d0,-4(a8)
              sw    d1,-8(a8)
              sw    d2,-12(a8)
              sw    d3,-16(a8)
              sw    d4,-20(a8)
              sw    a0,-24(a8)
              sw    ra,-28(a8)
              sw    d5,-32(a8)
              jal   dosprite
              nop
              lw    d0,-4(a8)
              lw    d1,-8(a8)
              lw    d2,-12(a8)
              lw    d3,-16(a8)
              lw    d4,-20(a8)
              lw    a0,-24(a8)
              lw    ra,-28(a8)
              lw    d5,-32(a8)

@SKIPSPACE
              addu  d0,8       ;next xpos
              addu  d2,-1
              bnez  d2,@nextletter
              nop
              move  d0,d5    ;xpos
              move  d2,d4    ;chars/line
              addu  d1,9     ;nextypos
              addu  d3,-1
              bnez  d3,@nextletter
              nop
              jr ra
              nop

spiralsin:  dw 0
              DW 1,1,1
SPIRALANGLES: DW 0,0,0

SPIRALTEXT:
              sw  ra,0(a8)

              la    a0,part4text
              li    d10,30        ;number of chars
              lw    d0,scrpointer
              addu  a0,a0,d0
              li    d2,-200        ;z start position on screen
              lw    d1,scrtime
              subu  d2,d2,d1      ;current z position
              lw    d3,spiralsin  ;current spiral
@nextletter:
              lbu   d8,0(a0)
              bnez  d8,@noreset
              nop
              la    a0,part4text       ;reset scroller
              lbu   d8,0(a0)
@noreset:
              lw    d7,fontsize  ;8=7,16=9,32=11

              addiu d8,d8,-32
              sllv  d8,d8,d7
              lw    d6,fonts
              addu  d6,d6,d8
              sw    d6,spritepointer    ;sprite graphics
            sw    d10,-4(a8)
            sw    a0,-8(a8)
            sw    d2,-12(a8)
            sw    d3,-16(a8)

            la      a0,sinuslist
            addiu   a1,a0,254    ;cos

            sll     d4,d3,1
            addu    a2,a1,d4   ;cos x
            lh      d5,0(a2)
            li      d6,120   ;circle radius
            mult    d5,d6
            mflo    d0      ;x
            sra     d0,14
            addu    a2,a0,d4  ;sin Y
            lh      d7,0(a2)
            mult    d7,d6
            mflo    d1      ;y
            sra     d1,14

           ;d0,d1= x,y  from circle calc
           ;d2 = current z

            la  a3,SPIRALANGLES

            lw  d3,0(a3)     ;angles
            lw  d4,4(a3)
            lw  d5,8(a3)

      sll  d3,d3,1   ;rotate 3 points with 3 angles
      sll  d4,d4,1   ;d0-d2  points (x,y,z)
      sll  d5,d5,1   ;d3-d5  angles (dx,dy,dz)
      addu a2,a0,d3  ;a0,a1  pointers to sin cos table
      lh   d6,0(a2)   ;sin(+x)
      mult d2,d6
      mflo d9         ;z*sin(+x)
      addu a2,a1,d3
      lh   d7,0(a2)   ;cos(+x)
      mult d1,d7
      mflo d10        ;y*cos(+x)
      subu d9,d10,d9  ;y*cos(+x)-z*sin(+x)
      sra  d9,d9,14   ;Y1 * 4 /65536
      mult d1,d6
      mflo d6         ;y*sin(+x)
      nop
      nop
      mult d2,d7
      mflo d7         ;z*cos(+x)
      addu d3,d7,d6   ;z*cos(+x)+ysin(+x)
      sra  d3,d3,14   ;Z1 * 4/65536
      addu a2,a0,d4
      lh   d6,0(a2)   ;sin(+y)
      mult d3,d6
      mflo d8         ;Z1*sin(+y)
      addu a2,a1,d4
      lh   d7,0(a2)   ;cos(+y)
      mult d0,d7
      mflo d10        ;x*cos(+y)
      subu d4,d10,d8  ;x*cos(+y)-z*sin(+y)
      sra  d4,d4,14   ;X2 *4/65536
      mult d0,d6
      mflo d6         ;z*sin(+y)
      nop
      nop
      mult d3,d7
      mflo d7         ;Z1*cos(+y)
      addu d2,d7,d6   ;x*sin(+y) + Z1*cos(+y)
      sra  d2,d2,14   ;final z coordinate
      addu a2,a0,d5
      lh   d6,0(a2)   ;sin(+z)
      mult d6,d9
      mflo d10        ;Y1 * sin(+z)
      addu a2,a1,d5
      lh   d7,0(a2)   ;cos(+z)
      mult d7,d4
      mflo d11        ;X2 * cos(+z)
      subu d0,d11,d10 ;X2*cos(+z)-Y1*sin(+z)
      sra  d0,d0,14   ;final X coordinate
      mult d4,d6
      mflo d6         ;X2*sin(+z)
      nop
      nop
      mult d9,d7
      mflo d7         ;Y1*cos(+z)
      addu d1,d6,d7   ;X2*sin(+z)+Y1*cos(+z)
      sra  d1,d1,14   ;final y coordinate


      addiu d2,d2,256    ;make values 0<z<512
      blez  d2,@skip


      lw    d3,zoom
      mult  d3,d0     ;x*zoom
      mflo  d0
      nop
      nop
      div   d0,d2     ;/z
      mflo  d0        ;projected x
      nop
      nop
      mult  d3,d1     ;y*zoom
      mflo  d1
      nop
      nop
      div   d1,d2     ;/z
      mflo  d1        ;projected y

      lw    d6,xcenter
      addu  d0,d6
      lw    d7,ycenter
      addu  d1,d7

      li    d5,$10000

      addu  d2,-256     ; -256  --  256
      bgezl d2,@shifta
      sll   d2,d2,8
      sll   d2,d2,5
@shifta
      subu  d5,d5,d2
      sw    d5,xscale
      sw    d5,yscale

      sw    d0,xposition
      sw    d1,yposition
      li    d0,16          ;size 16
      sw    d0,width
      sw    d0,height
      jal   dosprite
      nop
@skip
            lw    d10,-4(a8)
            lw    a0,-8(a8)
            lw    d2,-12(a8)
            lw    d3,-16(a8)
        addu a0,1   ;next letter
SPIRALSPACING = 40
SPIRALSPEED = 50
SPIRALTEXTSPEED = 8
        addu d2,SPIRALSPACING  ;z spacing
        addu d3,SPIRALSPEED
        andi d3,$1ff  ;circle speed
        bnez d10,@nextletter
        addu d10,-1



       ;**update scroll shit*****
              lw    d1,scrtime
              LI    d2,SPIRALTEXTSPEED
              addu  d1,d1,d2      ;time=time+speed
              li    d3,SPIRALSPACING

              subu  d4,d3,d1      ;spacing-time
              bgtz  d4,@updatetime
              nop
        lw   d5,spiralsin
        addu d5,SPIRALSPEED       ;circel speed
        andi d5,$1ff
        sw   d5,spiralsin
              
              subu  d1,d1,d3      ;time=time-spacing
              lw    d8,scrpointer
              addiu d8,d8,1
              la    a0,part4text
              addu  a0,a0,d8
              lbu   d9,0(a0)
              beql  d9,r0,@noresetpointer
              li    d8,0
@noresetpointer 
              sw    d8,scrpointer
@updatetime         
              sw    d1,scrtime

              lw  ra,0(a8)
              jr ra
              nop

part4text:
 DB 'HAY DUUUDES WHATS UP WITH THIS CRAZY CIRCLE SCROLL    HAY TO ALL '
 DB 'COOOLIO PEEPLE IN DA N64 CEEEN COZ YA KUTTIN PSIBLY READ!! THIS NOW COULD YA??'
 DB ' WELL THIS PART IS A HIDDEN PART TO THE MAIN DEMO  ... WELL HIDDEN IN '
 DB ' THE LOWER BORDER HEHEHE :)  WELL HERE ARE SOME MORE GREETS IF YA MISSED '
 DB 'EM IN THE LAST PART:  DUDDIE , LONGSHOT , NAGREVEIL ,NAGWURKIN ,PEZZA ,'
 DB 'PUREEVIL, RIDER , SPAMAN, ZILMAR, 64BIT ,AOHELL, CLIFFI, SHAIDAIR, SOME1,'
 DB ' STUMBLE, T64 , VIDEOMAN, KIDSTARD, -RIP- , LAC, ENNAY, NIL, ULTRA, SIXPAC, '
 DB 'ZYOP, TITANIK, WILDFIRE , NIGGAJOE, EBBHEAD, QSHARQ?? , MAGNETBOX, REDSKULL,'
 DB ' FREDRO , LETS SEE ARE THERE ANY MORE',0,0,0,0




 cnop 0,8
placegraphics:
 incbin  d:\gfx\anim\tronfont.aa
 
