;command line: asm filename send  base

width1 equ 16
height1 equ 16
xpos equ 0
ypos equ 180
;dump = 1
modikbuffer equ $A0500000
drawcolor = 1   ;for drawing
tricount equ 1024 ;12
tricmdsize equ  112 ;96

 include regs.asm
base equ   $80000400;$80310000$80000400;
 org (base-$1000)
 DCB $1000,0
;   OPT M-   ;NO MACROS
      ; BENTRO3


            li      a0,$b0001000+$F0000
            li      a1,(base+$F0000)|$A0000000
            la      a2,(RDP_end-base)/4
@bootcopy
            lw      d0,0(a0)
            addiu   a0,a0,4
            sw      d0,0(a1)
            sync
            cache   $10,0(a1)
            addiu   a1,a1,4
            bnez     a2,@bootcopy
            addiu   a2,a2,-1

            jal     INITVID  ;initialize video screen
            nop

            jal     ModikInit
            nop

            la      a8,stack
            jal     storeint
            nop
            jal     INITRDP
            nop

        li      a0,modikbuffer
        jal     ModikStartPlay
        nop
            jal     COPYDLlist
            nop

       jal RNDplot
       nop


START:

; include part1.asm

; include part2.asm

 include part3.asm

  include part4.asm

 include controller.asm
      


temp:   DW 10
;temp2: dw $2310
temp3:  DW tea  ;beginrdpcommand  ;where to look at
temp4:  DW tea  ;pipesync  ;setothermode ;beginrdpcommand
xstat: DW 0        ;0=peek memory 1=poke memory
alternate: DW 1
position1:  DW 0
position2: DW 0
color:   DW $1E00|drawcolor
color2:  DW $1E00|drawcolor
joypad: DW 0
lastbutton: DW 0


WTOF:
               lw      d3,$A4300008
               andi    d3,$8
               bnez    d3,@exit
               lui     a0,$A440     ;wait for TOF
@ZBAC:         lw      d1,$10(a0)
               addiu   d0,r0,$200
               bne    d0,d1,@ZBAC
               nop
@exit               
               sw      r0,$A4400010
               jr      ra
               nop

RNDplot:       lui     a0,$A410
               lw      a1,positioner
               lw      d9,antstars    ;number of stars
               addu    d9,2000
               addiu   d1,r0,1245
               addiu   d2,r0,13
               addiu   d3,r0,2
RNDLoop:       lw      d0,$10(a0)
               mult    d0,d1
               mflo    d0
               addiu   d0,d0,$100
               andi    d0,d0,$1FF
               addiu   d0,d0,$FFFFFF00
               sh      d0,0(a1)
               mult    d2,d1
               mflo    d1
               addu    d2,d2,d3
               lw      d0,$10(a0)
               sll     d1,d1,16
               sra     d1,d1,16
               mult    d1,d0
               mflo    d0
               addiu   d0,d0,$100
               andi    d0,d0,$1FF
               addiu   d0,d0,$FFFFFF00
               sh      d0,2(a1)
               mult    d2,d1
               mflo    d1
               addu    d2,d2,d3
               lw      d0,$10(a0)
               sll     d1,d1,16
               sra     d1,d1,16
               mult    d1,d0
               mflo    d0
               addiu   d0,d0,$100
               andi    d0,d0,$1FF
               addiu   d0,d0,$FFFFFF00
               sh      d0,4(a1)
               mult    d2,d1
               mflo    d1
               addu    d2,d2,d3
               sll     d1,d1,16
               sra     d1,d1,16
               addiu   a1,a1,6
               addiu   d9,d9,-1
               bne     d9,r0,RNDLoop
               nop
               jr ra
               nop
ADDz:        lw    a0,positioner
             addiu d0,r0,511
             lw    d1,Zadd
             addiu d3,r0,256
             lw    d7,antstars  ;number of stars
ZLoop:       lh    d2,4(a0)        ;(y,x,z) format
             addu  d2,d2,d3
             addu  d2,d2,d1
             and   d2,d2,d0
             subu  d2,d2,d3
             sh    d2,4(a0)
             addiu a0,a0,6
             bne   d7,r0,ZLoop
             addiu d7,d7,$FFFFFFFF
             jr ra
             nop


positioner: dw $80600000
antstars dw 300    ;490
Vadds:   DW 2,1,1
Vinklar: DW 0,0,0
stars:
zoom:    DW 180   ;180 is good
xcenter: DW 160
ycenter: DW 120
Zadd:    dw -9

drawstars:  la      a0,sinuslist
            addiu   a1,a0,254    ;cos
            la      a3,Vinklar
            lw      a4,positioner
            lw      a9,antstars    ;number of stars
@plotloop:
            lh  d0,0(a4)     ;coords
            lh  d1,2(a4)
            lh  d2,4(a4)
            lw  d3,0(a3)     ;angles
            lw  d4,4(a3)
            lw  d5,8(a3)
      sll  d3,d3,1   ;rotate 3 points with 3 angles
      sll  d4,d4,1   ;d0-d2  points (x,y,z)
      sll  d5,d5,1   ;d3-d5  angles (dx,dy,dz)
      addu a2,a0,d3  ;a0,a1  pointers to sin cos table
      lh   d6,0(a2)   ;sin(+x)
      mult d2,d6
      mflo d9         ;z*sin(+x)
      addu a2,a1,d3
      lh   d7,0(a2)   ;cos(+x)
      mult d1,d7
      mflo d10        ;y*cos(+x)
      subu d9,d10,d9  ;y*cos(+x)-z*sin(+x)
      sra  d9,d9,14   ;Y1/$4000
      mult d1,d6
      mflo d6         ;y*sin(+x)
      nop
      nop
      mult d2,d7
      mflo d7         ;z*cos(+x)
      addu d3,d7,d6   ;z*cos(+x)+ysin(+x)
      sra  d3,d3,14   ;Z1 /$4000
      addu a2,a0,d4
      lh   d6,0(a2)   ;sin(+y)
      mult d3,d6
      mflo d8         ;Z1*sin(+y)
      addu a2,a1,d4
      lh   d7,0(a2)   ;cos(+y)
      mult d0,d7
      mflo d10        ;x*cos(+y)
      subu d4,d10,d8  ;x*cos(+y)-z*sin(+y)
      sra  d4,d4,14   ;X2 /$4000
      mult d0,d6
      mflo d6         ;z*sin(+y)
      nop
      nop
      mult d3,d7
      mflo d7         ;Z1*cos(+y)
      addu d2,d7,d6   ;x*sin(+y) + Z1*cos(+y)
      sra  d2,d2,14   ;final z coordinate
      addu a2,a0,d5
      lh   d6,0(a2)   ;sin(+z)
      mult d6,d9
      mflo d10        ;Y1 * sin(+z)
      addu a2,a1,d5
      lh   d7,0(a2)   ;cos(+z)
      mult d7,d4
      mflo d11        ;X2 * cos(+z)
      subu d0,d11,d10 ;X2*cos(+z)-Y1*sin(+z)
      sra  d0,d0,14   ;final X coordinate
      mult d4,d6
      mflo d6         ;X2*sin(+z)
      nop
      nop
      mult d9,d7
      mflo d7         ;Y1*cos(+z)
      addu d1,d6,d7   ;X2*sin(+z)+Y1*cos(+z)
      sra  d1,d1,14   ;final y coordinate

      addiu a4,a4,6     ;increment coord  pointer

      addiu d2,d2,256    ;make values 0<z<512
      blez  d2,@skip
      andi  d2,d2,511    ;weed out shit


      lw    d3,zoom
      mult  d3,d0     ;x*zoom
      mflo  d0
      nop
      nop
      div   d0,d2     ;/z
      mflo  d0        ;projected x
      nop
      nop
      mult  d3,d1     ;y*zoom
      mflo  d1
      nop
      nop
      div   d1,d2     ;/z
      mflo  d1        ;projected y

      lw    d6,xcenter
      addu  d0,d6
      lw    d7,ycenter
      addu  d1,d7

      li    d5,$10000

      addu  d2,-256     ; -256  --  256
      bgezl d2,@shifta
      sll   d2,d2,8
      sll   d2,d2,5
@shifta
      subu  d5,d5,d2
      sw    d5,xscale
      sw    d5,yscale

      sw    d0,xposition
      sw    d1,yposition
      li    d0,16          ;size 16
      sw    d0,width
      sw    d0,height
      lw    a5,stargraphics
      sw    a5,spritepointer
      sw    ra,-4(a8)
      sw    a9,-8(a8)
      sw    a4,-16(a8)
      sw    a3,-20(a8)
      sw    a0,-24(a8)
      sw    a1,-28(a8)
      jal   dosprite
      nop
      lw    ra,-4(a8)
      lw    a9,-8(a8)
      lw    a4,-16(a8)
      lw    a3,-20(a8)
      lw    a0,-24(a8)
      lw    a1,-28(a8)


@skip:
      addiu a9,a9,-1
      bgtz  a9,@plotloop
      nop

      la  a0,vinklar
      la  a1,ship
      li  d1,3
@copyship
      lw  d0,0(a0)        ;whatever the position of stars
      addu a0,4           ;copy to the position of ship 
      sw  d0,-12(a1)      ;move only the stars!!
      addu d1,-1
      bnez d1,@copyship
      addu a1,4
      jr ra
      nop
  cnop 0,8
stargraphics: dw star

star:
 incbin d:\gfx\anim\balls\star1.aa
 
 include  vball.asm
 include  text.asm   ;info text
 include  dumper.asm
 include effects.asm
 include scroller.asm
 include logo.asm
 include sprite2.asm
 include triangle2.asm
 include copper.asm


     ;a0 = address of what object
addangles:
         li    d8,3

         addiu a0,a0,-4*6
@loop:
         lw    d0,0(a0)       ;vadd
         lw    d1,4*3(a0)      ;vinklar
         addu  d0,d0,d1       ;x+[x]
         andi  d0,d0,511      ;keep <511
         sw    d0,4*3(a0)
         addiu d8,d8,-1
         bnez  d8,@loop
         addiu a0,a0,4
         jr ra
         nop


 include RDP.asm
 include inits.asm


;format x1,y1,z1, x2,y2,z2, x3,y3,z3, n1,n2,n3, Zlimit ,color

obj1lightscale: DW 10
obj1zoom:    DW 0  ;256
obj1count:   DW 6
obj1xcenter: DW 160
obj1ycenter: DW 120
obj1Vadds:   DW 0,0,0
obj1Vinklar: DW 0,0,0
ship:
 include "\temp\ship.asm"

obj2lightscale: DW 90
obj2zoom:    DW 0
obj2count:   DW 320
obj2xcenter: DW 160
obj2ycenter: DW 120
obj2Vadds:   DW 0,2,2
obj2Vinklar: DW $80,0,0
geo:
  include "\temp\geo.asm"  ;320

obj3lightscale: DW 90
obj3zoom:    DW 0
obj3count:   DW 12
obj3xcenter: DW 160
obj3ycenter: DW 120
obj3Vadds:   DW 2,1,1
obj3Vinklar: DW 0,0,0
cube:
  include "\temp\cube.asm"  ;12

 DW 90   ;obj3lightscale:
 DW 100  ;obj3zoom:
 DW 12
 DW 40   ;x
 DW 40   ;y
 DW 1,1,2
 DW 0,0,0
cube2:
  include "\temp\cube.asm"  ;320

 DW 90   ;obj3lightscale:
 DW 100  ;obj3zoom:
 DW 12
 DW 320-40 ;x
 DW 40     ;y
 DW 4,1,0
 DW 0,0,0
cube3:
  include "\temp\cube.asm"  ;320

obj4lightscale: DW 42
obj4zoom:    DW 0
obj4count:   DW 110
obj4xcenter: DW 160
obj4ycenter: DW 120
obj4Vadds:   DW 1,0,3
obj4Vinklar: DW 0,0,0
checker:
 include "\temp\checker.asm"
  CNOP 0,4


 DW 90   ;obj3lightscale:
 DW 0  ;obj3zoom:
 DW 1024
 DW 160   ;x
 DW 120   ;y
 DW   4,1,0
 DW   0,0,0
tea:
  include "\temp\tea.asm"  ;1024

 DW 90   ;obj3lightscale:
 DW 0  ;obj3zoom:
 DW 576
 DW 160   ;x
 DW 120   ;y
 DW 0,5,0
 DW $b0,0,$80
torus:
  include "\temp\torus.asm"  ;576


checkdata: 
 DCB 32,0
  

     CNOP 0,8

rad:
 incbin d:\czn\64fonts
memory: DCB 64,0
 cnop 0,8
pixels:
 incbin d:\gfx\anim\new84.aa

sinuslist:
 incbin d:\czn\coding\sinus
 cnop 0,4


 include musak.asm

 CNOP 0,8
RDP_start:

           dw  $EF080CFF   ; RDPSetOtherMode
           dw  $00000000

           dw  $EF880CFF   ; RDPSetOtherMode
           dw  $00000000

           dw  $ED000000   ; SetScissor
           dw  $005003C0

           ;dw  $EF880CBF
           DW $EF890CFF;$EF892CFF;$EF892CBF  ; RDPSetOtherMode
           dw  $00000000

           DW $EF892CFF
           DW $0
           DW $EF892CBF
           DW $0

           DW $FC26A004  SetCombine
           DW $1FFC93FC

           dw  $E7000000   ; RDPPipeSync
           dw  $00000000

           dw  $FF10013F   ; SetCimg
SetCimg:   dw  $80400000-(320*240*2)

           dw  $E7000000   ; RDPPipeSync
           dw  $00000000

           dw  $EFB92CBF ; RDPSetOtherMode
           dw  $00000000

           dw  $EFB92CBF  ; RDPSetOtherMode
           dw  $0F0A4000

           dw  $F7000000   ; SetFillColor
           dw  $00010001   ;ALPHA??

           dw  $F64FC3BC   ; FillRect
           dw  $00000000   

           dw  $C0000000   ; Noop
           dw  $00000000

           dw  $E7000000   ; RDPPipeSync
           dw  $00000000 

           dw  $FF10013F   ; SetCimg
SetZimg:   dw  $00400000-(320*240*2)*3

           dw  $F7000000   ; SetFillColor
           dw  $FFFCFFFC

           dw  $F64FC3BC   ; FillRect
           dw  $00000000

           dw  $C0000000   ; Noop
           dw  $00000000

           dw  $E7000000   ; RDPPipeSync
           dw  $00000000

  dw $EF992CBF
  dw $0F0A4000
  dw $EF992CBF
  dw $0C182078

           dw  $FF10013F   ; SetCimg
SetCimg1:  dw  $80400000-(320*240*2)

           dw  $FE000000   ; SetZimg
           dw  $80400000-(320*240*2)
 ; CHANGE
;             dw $EF802CBF   ; RDPSetOtherMode
;             dw $0F0A7008   ;$00504240

;            dw $EF204CBF   ; RDPSetOtherMode
;            dw $00504240

;            dw $EF202CBF   ; RDPSetOtherMode
;            dw $00504200 
 ;sprite init
beginRDPcommand:
                   dw $E7000000
                   dw 0
                   REPT 2
                   dw $EF892CBF
                   dw $0C182078
                   ENDR
                   REPT 4
                   dw $EF812CBF
                   dw $0C182078
                   ENDR

                   REPT 2
                   dw $EF802CBF
                   dw $0C182078
                   ENDR

                   REPT 1
                   dw $EF802CBF 
                   dw $0F0A7008 
                   ENDR
           ; end sprite init
rectfill

           dw $EF802CBF
           dw $00504240
 
          dw  $E7000000   ; RDPPipeSync
          dw  $00000000


            dw $FA000000   ;SetPrimColor
            dw $FFFFFFFF

            dw $fc11fe23
            dw $fffff3f9



           dw  $C0000000   ; Noop        
           dw  $00000000

           dw  $C0000000   ; Noop
           dw  $00000000

;oldbegin
;           dw  $FD100000   ; SetTimg
;           dw  0  

;           dw  $F5100000   ; SetTile
;           DW  $07080200

;           dw  $E6000000   ; RDPLoadSync
;           dw  $00000000

;           dw  $F3000000   ; LoadBlock
;           DW  $077FF200   ;100 for 32, 400 for 8,200 for 16

;           dw  $E7000000   ; RDPPipeSync
;           dw  $00000000

;           DW $F5100000|(80/4)<<9  ; SetTile
 ;          dw $0000000E ;
;
;           dw  $F2000000   ; SetTileSize
 ;          dw  $0007C07C   ;(width-1)*4
;
;           DW  $e4000000|((32+80)<<14|200<<2)   ;xend<<2.yend<<2  texture rectangle
 ;          DW  (32<<14|100<<2)   ;xstart<<2.ystart<<2
 ;          Dw  0,$04000400
 ;
;           dw  $E7000000   ; RDPPipeSync
;           dw  $00000000
 ;
;           DW $FC300000  SetCombine
;           DW $00000300  ;$43020140
;
;           DW $F9000000
;           DW $FF000000
;
;          dw  $EF900CC1   ; RDPSetOtherMode
;          dw  $881A2078
;
;
;triangle:
;        REPT 12
; dw $CD000000
; dcb tricmdsize-4,0
;         ENDR
;  

     dw    $E9000000
     dw    $00000000
RDP_end:   nop
